// @ts-nocheck

$(function () {

  function bindServerRows() {
    $('#servers-table-body .jrebel-onoff').change(e => {
      vscode.postMessage({ handlerId: 'startupguideinstructions', type: 'jrebelToggled', serverId: $(e.target).attr('aria-server-name'), enable: e.target.checked || false });
    });
  }

  function updateServerRow(serverRow, isJRebelEnabled) {
    serverRow.find('.jrebel-onoff').prop('checked', isJRebelEnabled);
  }

  $('#startup-guide-runviaide').change(e => {
    handleRunviaideRadioChange($(e.currentTarget));
  });

  $('#startup-guide-runlocally').change(e => {
    handleRunlocallyRadioChange($(e.currentTarget));
  });

  $('#startup-guide-runremotely').change(e => {
    handleRunremotelyRadioChange($(e.currentTarget));
  });

  function handleRunviaideRadioChange(radio) {
    if (radio.prop("checked")) {
      $('#startup-guide-runviaide-container').removeClass("displaynone");
      $('#startup-guide-runlocally-container').addClass("displaynone");
      $('#startup-guide-runremotely-container').addClass("displaynone");
    }
  }

  function handleRunlocallyRadioChange(radio) {
    if (radio.prop("checked")) {
      $('#startup-guide-runviaide-container').addClass("displaynone");
      $('#startup-guide-runlocally-container').removeClass("displaynone");
      $('#startup-guide-runremotely-container').addClass("displaynone");
    }
  }

  function handleRunremotelyRadioChange(radio) {
    if (radio.prop("checked")) {
      $('#startup-guide-runviaide-container').addClass("displaynone");
      $('#startup-guide-runlocally-container').addClass("displaynone");
      $('#startup-guide-runremotely-container').removeClass("displaynone");
    }
  }

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    switch (event.data.type) {
      case 'updateAvailableServers':
        {
          const serversTableBody = $("#servers-table-body");
          serversTableBody.find(".cloned").remove();
          if (event.data.servers.length) {
            $('#no-servers-row').css('display', 'none');
            for (let server of event.data.servers) {
              const serverId = 'server-' + encodeURIComponent(server.serverHandle.id);
              const serverRow = $('#--template-server-row').clone();
              serverRow.prop('id', serverId + '-server-row');
              serverRow.html(serverRow.html()
                .replace(/--template-server/g, serverId)
                .replace(/--TEMPLATE-SERVER-NAME/g, server.serverHandle.id)
                .replace(/--template-sname/g, server.serverHandle.id)
              );
              updateServerRow(serverRow, server.isJRebelEnabled);
              serverRow.css('display', 'table-row');
              serverRow.addClass("cloned");
              serversTableBody.append(serverRow);
            }
            bindServerRows();
          } else {
            $('#no-servers-row').css('display', 'table-row');
          }
          break;
        }
    }
  });

  vscode.postMessage({ handlerId: 'startupguideinstructions', type: 'startupguideinstructionsShown' });
});